libzypp 17.37.10

zypp::repo::ServiceException Class Reference

Base Exception for service handling. More...

`#include <zypp/repo/RepoException.h>`

Inheritance diagram for zypp::repo::ServiceException:

## Public Member Functions
| ServiceException ()
| ServiceException (const std::string &msg_r)
| ServiceException (const ServiceInfo &service_r)
| ServiceException (const ServiceInfo &service_r, const std::string &msg_r)
| ~ServiceException () override throw ()
ServiceInfo | service ()
std::string | alias ()
Public Member Functions inherited from zypp::Exception
| Exception ()
| Default ctor.
| Exception (const std::string &msg_r)
| Ctor taking a message.
| Exception (std::string &&msg_r)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
| Exception (const std::string &msg_r, const Exception &history_r)
| Ctor taking a message and an exception to remember as history.
| Exception (std::string &&msg_r, const Exception &history_r)
| Exception (const std::string &msg_r, Exception &&history_r)
| Exception (std::string &&msg_r, Exception &&history_r)
| ~Exception () override throw ()
| Dtor.
const CodeLocation & | where () const
| Return CodeLocation.
void | relocate (const CodeLocation &where_r) const
| Exchange location on rethrow.
void | relocate (CodeLocation &&where_r) const
| Exchange location on rethrow.
const std::string & | msg () const
| Return the message string provided to the ctor.
std::string | asString () const
| Error message provided by dumpOn as string.
std::string | asUserString () const
| Translated error message as string suitable for the user.
void | remember (const Exception &old_r)
| Store an other Exception as history.
void | remember (Exception &&old_r)
void | remember (std::exception_ptr old_r)
void | remember (const std::string &msg_r)
| Remembering a plain string is most probably not wanted - we addHistory.
void | remember (std::string &&msg_r)
void | addHistory (const std::string &msg_r)
| Add some message text to the history.
void | addHistory (std::string &&msg_r)
template<class TContainer>
void | addToHistory (const TContainer &msgc_r)
| addHistory from string container types (oldest first)
template<class TContainer>
void | moveToHistory (TContainer &&msgc_r)
| addHistory from string container types (oldest first) moving
HistoryIterator | historyBegin () const
| Iterator pointing to the most recent message.
HistoryIterator | historyEnd () const
| Iterator pointing behind the last message.
bool | historyEmpty () const
| Whether the history list is empty.
HistorySize | historySize () const
| The size of the history list.
std::string | historyAsString () const
| The history as string.
std::string | asUserHistory () const
| A single (multiline) string composed of asUserString and historyAsString.

## Protected Member Functions
std::ostream & | dumpOn (std::ostream &str) const override
| Overload this to print a proper error message.

## Private Attributes
ServiceInfo | _service

## Additional Inherited Members
Public Types inherited from zypp::Exception
using | CodeLocation = exception_detail::CodeLocation
using | History = std::list<std::string>
using | HistoryIterator = History::const_iterator
using | HistorySize = History::size_type
static std::string | strErrno (int errno_r)
| Make a string from errno_r.
static std::string | strErrno (int errno_r, std::string msg_r)
| Make a string from errno_r and msg_r.
static void | log (const Exception &excpt_r, const CodeLocation &where_r, const char *const prefix_r)
| Drop a logline on throw, catch or rethrow.
static void | log (const char *typename_r, const CodeLocation &where_r, const char *const prefix_r)
| \overrload for not-Exception types thrown via ZYPP_THROW
Related Symbols inherited from zypp::Exception
std::ostream & | operator<< (std::ostream &str, const Exception &obj) ZYPP_API
| Stream output.

## Detailed Description

Base Exception for service handling.

Definition at line 188 of file RepoException.h.

## Constructor & Destructor Documentation

## ◆ ServiceException() [1/4]

zypp::repo::ServiceException::ServiceException | ( |  | ) |

Definition at line 83 of file RepoException.cc.

## ◆ ServiceException() [2/4]

zypp::repo::ServiceException::ServiceException | ( | const std::string & | msg_r | ) |

Definition at line 87 of file RepoException.cc.

## ◆ ServiceException() [3/4]

zypp::repo::ServiceException::ServiceException | ( | const ServiceInfo & | service_r | ) |

Definition at line 91 of file RepoException.cc.

## ◆ ServiceException() [4/4]

zypp::repo::ServiceException::ServiceException | ( | const ServiceInfo & | service_r,
|  | const std::string & | msg_r )

Definition at line 95 of file RepoException.cc.

## ◆ ~ServiceException()

zypp::repo::ServiceException::~ServiceException | ( |  | ) |
throw | ( | ) |  |  |
| override

Definition at line 99 of file RepoException.cc.

## Member Function Documentation

## ◆ service()

ServiceInfo zypp::repo::ServiceException::service | ( |  | ) |
| inline

Definition at line 197 of file RepoException.h.

## ◆ alias()

std::string zypp::repo::ServiceException::alias | ( |  | ) |
| inline

Definition at line 200 of file RepoException.h.

## ◆ dumpOn()

std::ostream & zypp::repo::ServiceException::dumpOn | ( | std::ostream & | str | ) | const
| override protected virtual

Overload this to print a proper error message.

Reimplemented from zypp::Exception.

Definition at line 102 of file RepoException.cc.

## Member Data Documentation

## ◆ _service

ServiceInfo zypp::repo::ServiceException::_service
| private

Definition at line 207 of file RepoException.h.

The documentation for this class was generated from the following files:

- zypp/repo/RepoException.h
- zypp/repo/RepoException.cc